<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<title>CSS and Bootstrap Flex</title>
		<!-- External CSS -->
		<!-- <link rel="stylesheet" type="text/css" href="index.css"> -->

		<!-- Bootstrap CSS -->
		<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">

		<!-- 
		shortcut keys:
		ctrl enter 				> new line
		ctrl shift D 			> to copy and paste a code line
		ctrl shift key up/down	> to move the code line
		hold ctrl and click the items you need to type in to
		 -->
	</head>

	<body>
		<div class="text-center">
			<h1>Bootstrap Flex</h1>
			<p>
				Use the d-flex class to create a flex container and transform direct children into flex items
			</p>

			<h2>Centering Elements</h2>
			<div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column-reverse">
				<div class="h-25 p-3 bg-success">Flex Item A</div>
				<div class="h-25 p-3 bg-warning">Flex Item B</div>
				<div class="h-25 p-3 bg-danger">Flex Item C</div>
			</div>

			<h2>Flex Row</h2>
			<div class="bg-dark p-3 d-flex flex-row">
				<div class="p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
			</div>

			<h2>Flex Row Reverse</h2>
			<div class="bg-dark p-3 d-flex flex-row-reverse">
				<div class="p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
			</div>

			<h2>Creating Space Between Elements</h2>
			<!-- *justify-content-around class centers elements horizontally while creating space between elements and the borders of it's parent container -->
			<div class="bg-dark p-3 d-md-flex justify-content-around">
				<div class="p-3 bg-success col-md-2">Flex Item A</div>
				<div class="p-3 bg-warning col-md-2">Flex Item B</div>
				<div class="p-3 bg-danger col-md-2">Flex Item C</div>
			</div>

			<h2>Flexbox with Margins</h2>
			<div class="bg-dark p-3 d-md-flex">
				<div class="p-3 bg-success me-auto">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
				<div class="p-3 bg-primary">Flex Item D</div>
			</div>

			<h2>Nested Flex Elements</h2>
			<div class="bg-dark p-3 d-block d-md-flex">
				<div class="p-3 bg-success me-auto">Flex Item A</div>
				<div class="w-50 d-block d-md-flex justify-content-between">
					<!-- *justify-around -->
					<div class="p-3 bg-warning">Flex Item B</div>
					<div class="p-3 bg-danger">Flex Item C</div>
					<div class="p-3 bg-primary">Flex Item D</div>
			</div>
			</div>

		</div>

		<!-- Bootstrap CSS -->
		<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
	</body>
</html>